Index: issm/branches/trunk-jpl-damage/src/c/Makefile.am
===================================================================
--- issm/branches/trunk-jpl-damage/src/c/Makefile.am	(revision 12877)
+++ issm/branches/trunk-jpl-damage/src/c/Makefile.am	(revision 12878)
@@ -1,8 +1,12 @@
-INCLUDES = @DAKOTAINCL@ @SHAPELIBINCL@ @PETSCINCL@ @SLEPCINCL@ @MPIINCL@ @MATLABINCL@ @METISINCL@ @CHACOINCL@ @SCOTCHINCL@ @PLAPACKINCL@ @BLASLAPACKINCL@ @MKLINCL@ @MUMPSINCL@ @TRIANGLEINCL@ @HYPREINCL@ @MLINCL@ @TAOINCL@ @ADIC2INCL@ @ADOLCINCL@ @GSLINCL@ @BOOSTINCL@ @PYTHONINCL@ @PYTHON_NUMPYINCL@
+INCLUDES = @DAKOTAINCL@ @SHAPELIBINCL@ @PETSCINCL@ @SLEPCINCL@ @MPIINCL@ @MATLABINCL@ @METISINCL@ @CHACOINCL@ @SCOTCHINCL@ @PLAPACKINCL@ @BLASLAPACKINCL@ @MKLINCL@ @MUMPSINCL@ @TRIANGLEINCL@ @SPAIINCL@ @HYPREINCL@ @PROMETHEUSINCL@ @SUPERLUINCL@ @SPOOLESINCL@ @PASTIXINCL@ @MLINCL@ @TAOINCL@ @ADIC2INCL@ @ADOLCINCL@ @GSLINCL@ @BOOSTINCL@ @PYTHONINCL@ @PYTHON_NUMPYINCL@
 
 EXEEXT=$(ISSMEXT)
 
-#Library declaration {{{1
-lib_LIBRARIES = libISSMCore.a libISSMModules.a libISSMOverload.a
+#Library declaration {{{
+lib_LIBRARIES = libISSMCore.a libISSMOverload.a
+
+#if SHARED
+#lib_LTLIBRARIES = libISSM.la libISSMCore.la libISSMOverload.la
+#endif
 if PYTHON
 lib_LIBRARIES += libISSMPython.a 
@@ -11,8 +15,11 @@
 lib_LIBRARIES += libISSMMatlab.a 
 endif
+if MODULES
+lib_LIBRARIES += libISSMModules.a 
+endif
 #}}}
 
 #sources
-#Core sources{{{1
+#Core sources{{{
 core_sources = ./issm.h\
 					./issm-binding.h\
@@ -21,130 +28,134 @@
 					./include/types.h\
 					./include/include.h\
-					./objects/objects.h\
-					./objects/Object.h\
-					./objects/Gauss/GaussTria.h\
-					./objects/Gauss/GaussTria.cpp\
-					./objects/Update.h\
-					./objects/Element.h\
-					./objects/FemModel.h\
-					./objects/FemModel.cpp\
-					./objects/Material.h\
-					./objects/Load.h\
-					./objects/Contour.h\
-					./objects/Contour.cpp\
-					./objects/OptArgs.h\
-					./objects/OptPars.h\
-					./objects/Loads/Friction.h\
-					./objects/Loads/Friction.cpp\
-					./objects/Inputs/TransientInput.h\
-					./objects/Inputs/TransientInput.cpp\
-					./objects/Constraints/SpcTransient.cpp\
-					./objects/Constraints/SpcTransient.h\
-					./objects/DofIndexing.h\
-					./objects/DofIndexing.cpp\
-					./objects/IoModel.h\
-					./objects/IoModel.cpp\
-					./objects/Node.h\
-					./objects/Node.cpp\
-					./objects/Segment.h\
-					./objects/Segment.cpp\
-					./objects/Vertex.h\
-					./objects/Vertex.cpp\
-					./objects/Hook.h\
-					./objects/Hook.cpp\
-					./objects/Patch.h\
-					./objects/Patch.cpp\
-					./objects/ElementResults/ElementResultLocal.h\
-					./objects/ElementResults/DoubleElementResult.h\
-					./objects/ElementResults/DoubleElementResult.cpp\
-					./objects/ElementResults/TriaP1ElementResult.h\
-					./objects/ElementResults/TriaP1ElementResult.cpp\
-					./objects/ElementResults/BoolElementResult.h\
-					./objects/ElementResults/BoolElementResult.cpp\
-					./objects/ExternalResults/ExternalResult.h\
-					./objects/ExternalResults/BoolExternalResult.h\
-					./objects/ExternalResults/BoolExternalResult.cpp\
-					./objects/ExternalResults/DoubleExternalResult.h\
-					./objects/ExternalResults/DoubleExternalResult.cpp\
-					./objects/ExternalResults/DoubleVecExternalResult.h\
-					./objects/ExternalResults/DoubleVecExternalResult.cpp\
-					./objects/ExternalResults/DoubleMatExternalResult.h\
-					./objects/ExternalResults/DoubleMatExternalResult.cpp\
-					./objects/ExternalResults/IntExternalResult.h\
-					./objects/ExternalResults/IntExternalResult.cpp\
-					./objects/ExternalResults/StringExternalResult.h\
-					./objects/ExternalResults/StringExternalResult.cpp\
-					./objects/Elements/Tria.h\
-					./objects/Elements/Tria.cpp\
-					./objects/Elements/TriaHook.h\
-					./objects/Elements/TriaHook.cpp\
-					./objects/Elements/TriaRef.h\
-					./objects/Elements/TriaRef.cpp\
-					./objects/Inputs/Input.h\
-					./objects/Inputs/InputLocal.h\
-					./objects/Inputs/TriaP1Input.h\
-					./objects/Inputs/TriaP1Input.cpp\
-					./objects/Inputs/BoolInput.h\
-					./objects/Inputs/BoolInput.cpp\
-					./objects/Inputs/IntInput.h\
-					./objects/Inputs/IntInput.cpp\
-					./objects/Inputs/DoubleInput.h\
-					./objects/Inputs/DoubleInput.cpp\
-					./objects/Inputs/DatasetInput.h\
-					./objects/Inputs/DatasetInput.cpp\
-					./objects/Materials/Matice.h\
-					./objects/Materials/Matice.cpp\
-					./objects/Materials/Matpar.h\
-					./objects/Materials/Matpar.cpp\
-					./objects/Constraints/Constraint.h\
-					./objects/Constraints/SpcStatic.cpp\
-					./objects/Constraints/SpcStatic.h\
-					./objects/Constraints/SpcDynamic.cpp\
-					./objects/Constraints/SpcDynamic.h\
-					./objects/Loads/Penpair.cpp\
-					./objects/Loads/Penpair.h\
-					./objects/Loads/Pengrid.cpp\
-					./objects/Loads/Pengrid.h\
-					./objects/Loads/Icefront.cpp\
-					./objects/Loads/Icefront.h\
-					./objects/Loads/Numericalflux.cpp\
-					./objects/Loads/Numericalflux.h\
-					./objects/Numerics/ElementMatrix.h\
-					./objects/Numerics/ElementMatrix.cpp\
-					./objects/Numerics/ElementVector.h\
-					./objects/Numerics/ElementVector.cpp\
-					./objects/Numerics/Matrix.h\
-					./objects/Numerics/Matrix.cpp\
-					./objects/Numerics/Vector.h\
-					./objects/Numerics/Vector.cpp\
-					./objects/Params/Param.h\
-					./objects/Params/BoolParam.cpp\
-					./objects/Params/BoolParam.h\
-					./objects/Params/IntParam.cpp\
-					./objects/Params/IntParam.h\
-					./objects/Params/IntVecParam.cpp\
-					./objects/Params/IntVecParam.h\
-					./objects/Params/IntMatParam.cpp\
-					./objects/Params/IntMatParam.h\
-					./objects/Params/DoubleParam.cpp\
-					./objects/Params/DoubleParam.h\
-					./objects/Params/FileParam.cpp\
-					./objects/Params/FileParam.h\
-					./objects/Params/StringArrayParam.cpp\
-					./objects/Params/StringArrayParam.h\
-					./objects/Params/DoubleMatParam.cpp\
-					./objects/Params/DoubleMatParam.h\
-					./objects/Params/DoubleTransientMatParam.cpp\
-					./objects/Params/DoubleTransientMatParam.h\
-					./objects/Params/DoubleMatArrayParam.cpp\
-					./objects/Params/DoubleMatArrayParam.h\
-					./objects/Params/DoubleVecParam.cpp\
-					./objects/Params/DoubleVecParam.h\
-					./objects/Params/StringParam.cpp\
-					./objects/Params/StringParam.h\
-					./objects/Params/MatrixParam.h\
-					./objects/Params/MatrixParam.cpp\
-					./objects/Params/VectorParam.h\
-					./objects/Params/VectorParam.cpp\
+					./classes/classes.h\
+					./classes/objects.h\
+					./classes/objects/Object.h\
+					./classes/gauss/GaussTria.h\
+					./classes/gauss/GaussTria.cpp\
+					./classes/objects/Update.h\
+					./classes/objects/Element.h\
+					./classes/FemModel.h\
+					./classes/FemModel.cpp\
+					./classes/objects/Material.h\
+					./classes/objects/Load.h\
+					./classes/objects/Contour.h\
+					./classes/objects/Contour.cpp\
+					./classes/objects/OptArgs.h\
+					./classes/objects/OptPars.h\
+					./classes/objects/Loads/Friction.h\
+					./classes/objects/Loads/Friction.cpp\
+					./classes/objects/Inputs/TransientInput.h\
+					./classes/objects/Inputs/TransientInput.cpp\
+					./classes/objects/Constraints/SpcTransient.cpp\
+					./classes/objects/Constraints/SpcTransient.h\
+					./classes/DofIndexing.h\
+					./classes/DofIndexing.cpp\
+					./classes/IoModel.h\
+					./classes/IoModel.cpp\
+					./classes/objects/Node.h\
+					./classes/objects/Node.cpp\
+					./classes/objects/Segment.h\
+					./classes/objects/Segment.cpp\
+					./classes/objects/Vertex.h\
+					./classes/objects/Vertex.cpp\
+					./classes/Hook.h\
+					./classes/Hook.cpp\
+					./classes/Patch.h\
+					./classes/Patch.cpp\
+					./classes/objects/ElementResults/ElementResultLocal.h\
+					./classes/objects/ElementResults/DoubleElementResult.h\
+					./classes/objects/ElementResults/DoubleElementResult.cpp\
+					./classes/objects/ElementResults/TriaP1ElementResult.h\
+					./classes/objects/ElementResults/TriaP1ElementResult.cpp\
+					./classes/objects/ElementResults/BoolElementResult.h\
+					./classes/objects/ElementResults/BoolElementResult.cpp\
+					./classes/objects/ExternalResults/ExternalResult.h\
+					./classes/objects/ExternalResults/BoolExternalResult.h\
+					./classes/objects/ExternalResults/BoolExternalResult.cpp\
+					./classes/objects/ExternalResults/DoubleExternalResult.h\
+					./classes/objects/ExternalResults/DoubleExternalResult.cpp\
+					./classes/objects/ExternalResults/DoubleVecExternalResult.h\
+					./classes/objects/ExternalResults/DoubleVecExternalResult.cpp\
+					./classes/objects/ExternalResults/DoubleMatExternalResult.h\
+					./classes/objects/ExternalResults/DoubleMatExternalResult.cpp\
+					./classes/objects/ExternalResults/IntExternalResult.h\
+					./classes/objects/ExternalResults/IntExternalResult.cpp\
+					./classes/objects/ExternalResults/StringExternalResult.h\
+					./classes/objects/ExternalResults/StringExternalResult.cpp\
+					./classes/objects/Elements/Tria.h\
+					./classes/objects/Elements/Tria.cpp\
+					./classes/objects/Elements/TriaHook.h\
+					./classes/objects/Elements/TriaHook.cpp\
+					./classes/objects/Elements/TriaRef.h\
+					./classes/objects/Elements/TriaRef.cpp\
+					./classes/objects/Inputs/Input.h\
+					./classes/objects/Inputs/InputLocal.h\
+					./classes/objects/Inputs/TriaP1Input.h\
+					./classes/objects/Inputs/TriaP1Input.cpp\
+					./classes/objects/Inputs/BoolInput.h\
+					./classes/objects/Inputs/BoolInput.cpp\
+					./classes/objects/Inputs/IntInput.h\
+					./classes/objects/Inputs/IntInput.cpp\
+					./classes/objects/Inputs/DoubleInput.h\
+					./classes/objects/Inputs/DoubleInput.cpp\
+					./classes/objects/Inputs/DatasetInput.h\
+					./classes/objects/Inputs/DatasetInput.cpp\
+					./classes/objects/Materials/Matice.h\
+					./classes/objects/Materials/Matice.cpp\
+					./classes/objects/Materials/Matpar.h\
+					./classes/objects/Materials/Matpar.cpp\
+					./classes/objects/Constraints/Constraint.h\
+					./classes/objects/Constraints/SpcStatic.cpp\
+					./classes/objects/Constraints/SpcStatic.h\
+					./classes/objects/Constraints/SpcDynamic.cpp\
+					./classes/objects/Constraints/SpcDynamic.h\
+					./classes/objects/Loads/Penpair.cpp\
+					./classes/objects/Loads/Penpair.h\
+					./classes/objects/Loads/Pengrid.cpp\
+					./classes/objects/Loads/Pengrid.h\
+					./classes/objects/Loads/Icefront.cpp\
+					./classes/objects/Loads/Icefront.h\
+					./classes/objects/Loads/Numericalflux.cpp\
+					./classes/objects/Loads/Numericalflux.h\
+					./classes/matrix/matrixobjects.h\
+					./classes/matrix/ElementMatrix.h\
+					./classes/matrix/ElementMatrix.cpp\
+					./classes/matrix/ElementVector.h\
+					./classes/matrix/ElementVector.cpp\
+					./classes/matrix/Matrix.h\
+					./classes/matrix/Matrix.cpp\
+					./classes/matrix/Vector.h\
+					./classes/matrix/Vector.cpp\
+					./classes/objects/Params/Param.h\
+					./classes/objects/Params/BoolParam.cpp\
+					./classes/objects/Params/BoolParam.h\
+					./classes/objects/Params/IntParam.cpp\
+					./classes/objects/Params/IntParam.h\
+					./classes/objects/Params/IntVecParam.cpp\
+					./classes/objects/Params/IntVecParam.h\
+					./classes/objects/Params/IntMatParam.cpp\
+					./classes/objects/Params/IntMatParam.h\
+					./classes/objects/Params/DoubleParam.cpp\
+					./classes/objects/Params/DoubleParam.h\
+					./classes/objects/Params/FileParam.cpp\
+					./classes/objects/Params/FileParam.h\
+					./classes/objects/Params/StringArrayParam.cpp\
+					./classes/objects/Params/StringArrayParam.h\
+					./classes/objects/Params/DoubleMatParam.cpp\
+					./classes/objects/Params/DoubleMatParam.h\
+					./classes/objects/Params/DoubleTransientMatParam.cpp\
+					./classes/objects/Params/DoubleTransientMatParam.h\
+					./classes/objects/Params/DoubleMatArrayParam.cpp\
+					./classes/objects/Params/DoubleMatArrayParam.h\
+					./classes/objects/Params/DoubleVecParam.cpp\
+					./classes/objects/Params/DoubleVecParam.h\
+					./classes/objects/Params/StringParam.cpp\
+					./classes/objects/Params/StringParam.h\
+					./classes/objects/Params/MatrixParam.h\
+					./classes/objects/Params/MatrixParam.cpp\
+					./classes/objects/Params/VectorParam.h\
+					./classes/objects/Params/VectorParam.cpp\
+					./classes/objects/Params/TransientParam.h\
+					./classes/objects/Params/TransientParam.cpp\
 					./Container/Container.h\
 					./Container/Constraints.h\
@@ -173,8 +184,8 @@
 					./shared/Alloc/alloc.h\
 					./shared/Alloc/alloc.cpp\
+					./shared/Alloc/xNewDelete.h\
+					./shared/MemOps/xMemCpy.h\
 					./shared/Matrix/matrix.h\
 					./shared/Matrix/MatrixUtils.cpp\
-					./shared/Dofs/dofs.h\
-					./shared/Dofs/dofsetgen.cpp\
 					./shared/Numerics/numerics.h\
 					./shared/Numerics/Verbosity.h\
@@ -202,8 +213,14 @@
 					./shared/Elements/GetGlobalDofList.cpp\
 					./shared/Elements/GetNumberOfDofs.cpp\
+					./shared/Elements/PrintArrays.cpp\
+					./shared/Elements/PddSurfaceMassBalance.cpp\
+					./shared/Elements/ComputeDelta18oTemperaturePrecipitation.cpp\
 					./shared/String/sharedstring.h\
 					./shared/Wrapper/wrappershared.h\
 					./shared/Wrapper/ModuleBoot.cpp\
 					./shared/Wrapper/ModuleEnd.cpp\
+					./shared/Sys/sys.h\
+					./shared/Sys/ProfilingStart.cpp\
+					./shared/Sys/ProfilingEnd.cpp\
 					./toolkits/metis/metisincludes.h\
 					./toolkits/issm/issmtoolkit.h\
@@ -281,4 +298,8 @@
 					./modules/PositiveDegreeDayx/PositiveDegreeDayx.h\
 					./modules/PositiveDegreeDayx/PositiveDegreeDayx.cpp\
+					./modules/Delta18oParameterizationx/Delta18oParameterizationx.h\
+					./modules/Delta18oParameterizationx/Delta18oParameterizationx.cpp\
+					./modules/SmbGradientsx/SmbGradientsx.h\
+					./modules/SmbGradientsx/SmbGradientsx.cpp\
 					./modules/UpdateConstraintsx/UpdateConstraintsx.h\
 					./modules/UpdateConstraintsx/UpdateConstraintsx.cpp\
@@ -310,4 +331,5 @@
 					./modules/Solverx/Solverx.cpp\
 					./modules/Solverx/Solverx.h\
+					./modules/Solverx/SolverxSeq.cpp\
 					./modules/VecMergex/VecMergex.cpp\
 					./modules/VecMergex/VecMergex.h\
@@ -326,9 +348,24 @@
 					./solvers/solver_linear.cpp\
 					./solvers/solver_nonlinear.cpp\
-					./solvers/solver_newton.cpp
-#}}}
-#DAKOTA sources  {{{1
-dakota_sources = ./objects/DakotaPlugin.h\
-					  ./objects/DakotaPlugin.cpp\
+					./solvers/solver_newton.cpp\
+					./classes/objects/Options/Option.cpp\
+					./classes/objects/Options/Option.h\
+					./classes/objects/Options/OptionDouble.cpp\
+					./classes/objects/Options/OptionDouble.h\
+					./classes/objects/Options/OptionChar.cpp\
+					./classes/objects/Options/OptionChar.h\
+					./classes/objects/Options/OptionUtilities.cpp\
+					./classes/objects/Options/OptionUtilities.h\
+					./classes/objects/Options/OptionLogical.cpp\
+					./classes/objects/Options/OptionLogical.h\
+					./classes/objects/Options/OptionStruct.cpp\
+					./classes/objects/Options/OptionStruct.h\
+					./classes/objects/Options/OptionCell.cpp\
+					./classes/objects/Options/OptionCell.h
+
+#}}}
+#DAKOTA sources  {{{
+dakota_sources = ./classes/dakota/DakotaPlugin.h\
+					  ./classes/dakota/DakotaPlugin.cpp\
 					  ./modules/InputUpdateFromDakotax/InputUpdateFromDakotax.h\
 					  ./modules/InputUpdateFromDakotax/InputUpdateFromDakotax.cpp\
@@ -352,13 +389,13 @@
 					  ./modules/Dakotax/SpawnCoreParallel.cpp
 #}}}
-#Transient sources  {{{1
+#Transient sources  {{{
 transient_sources  = ./modules/ModelProcessorx/Transient/UpdateElementsTransient.cpp \
 					 ./solutions/transient_core.cpp
 #}}}
-#Steadystate sources  {{{1
+#Steadystate sources  {{{
 steadystate_sources = ./solutions/steadystate_core.cpp\
 					  ./solutions/steadystateconvergence.cpp
 #}}}
-#Prognostic sources  {{{1
+#Prognostic sources  {{{
 prognostic_sources = ./modules/ModelProcessorx/Prognostic/UpdateElementsPrognostic.cpp\
 					      ./modules/ModelProcessorx/Prognostic/CreateNodesPrognostic.cpp\
@@ -367,5 +404,5 @@
 						  ./solutions/prognostic_core.cpp
 #}}}
-#Thermal sources  {{{1
+#Thermal sources  {{{
 thermal_sources = ./modules/ModelProcessorx/Thermal/UpdateElementsThermal.cpp\
 					   ./modules/ModelProcessorx/Thermal/CreateNodesThermal.cpp\
@@ -387,5 +424,5 @@
 					   ./solvers/solver_thermal_nonlinear.cpp
 #}}}
-#Control sources  {{{1
+#Control sources  {{{
 control_sources= ./modules/ControlInputGetGradientx/ControlInputGetGradientx.cpp\
 					  ./modules/ControlInputGetGradientx/ControlInputGetGradientx.h\
@@ -426,6 +463,6 @@
 					  ./modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.cpp\
 					  ./modules/RheologyBbarAbsGradientx/RheologyBbarAbsGradientx.h\
-					  ./objects/Inputs/ControlInput.h\
-					  ./objects/Inputs/ControlInput.cpp\
+					  ./classes/objects/Inputs/ControlInput.h\
+					  ./classes/objects/Inputs/ControlInput.cpp\
 					  ./shared/Numerics/BrentSearch.cpp\
 					  ./shared/Numerics/OptimalSearch.cpp \
@@ -442,5 +479,5 @@
 
 #}}}
-#Hydrology sources  {{{1
+#Hydrology sources  {{{
 hydrology_sources  = ./modules/ModelProcessorx/Hydrology/UpdateElementsHydrology.cpp\
 					      ./modules/ModelProcessorx/Hydrology/CreateNodesHydrology.cpp\
@@ -450,5 +487,5 @@
 						  ./solutions/hydrology_core_step.cpp 
 #}}}
-#Diagnostic sources  {{{1
+#Diagnostic sources  {{{
 diagnostic_sources = ./modules/ModelProcessorx/DiagnosticHoriz/UpdateElementsDiagnosticHoriz.cpp\
 					      ./modules/ModelProcessorx/DiagnosticHoriz/CreateNodesDiagnosticHoriz.cpp \
@@ -471,5 +508,5 @@
 						  ./solvers/solver_stokescoupling_nonlinear.cpp
 #}}}
-#Balanced sources  {{{1
+#Balanced sources  {{{
 balanced_sources = ./modules/ModelProcessorx/Balancethickness/UpdateElementsBalancethickness.cpp\
 					    ./modules/ModelProcessorx/Balancethickness/CreateNodesBalancethickness.cpp\
@@ -478,5 +515,5 @@
 						./solutions/balancethickness_core.cpp
 #}}}
-#Responses sources  {{{1
+#Responses sources  {{{
 responses_sources = ./modules/MinVelx/MinVelx.h\
 					     ./modules/MinVelx/MinVelx.cpp\
@@ -501,4 +538,6 @@
 					     ./modules/MinVzx/MinVzx.h\
 					     ./modules/MinVzx/MinVzx.cpp\
+					     ./modules/TotalSmbx/TotalSmbx.h\
+					     ./modules/TotalSmbx/TotalSmbx.cpp\
 					     ./modules/IceVolumex/IceVolumex.h\
 					     ./modules/IceVolumex/IceVolumex.cpp\
@@ -508,5 +547,5 @@
 					     ./modules/MassFluxx/MassFluxx.h
 #}}}
-#Slope sources  {{{1
+#Slope sources  {{{
 slope_sources =  ./modules/ModelProcessorx/BedSlope/UpdateElementsBedSlope.cpp\
 					  ./modules/ModelProcessorx/BedSlope/CreateNodesBedSlope.cpp \
@@ -520,77 +559,78 @@
 					  ./solutions/bedslope_core.cpp
 #}}}
-#Groundingline sources  {{{1
+#Groundingline sources  {{{
 groundingline_sources= ./modules/GroundinglineMigrationx/GroundinglineMigrationx.cpp\
 					        ./modules/GroundinglineMigrationx/GroundinglineMigrationx.h
 #}}}
-#Rifts sources  {{{1
-rifts_sources = ./objects/Loads/Riftfront.cpp\
-				    ./objects/Loads/Riftfront.h\
+#Rifts sources  {{{
+rifts_sources = ./classes/objects/Loads/Riftfront.cpp\
+				    ./classes/objects/Loads/Riftfront.h\
 				    ./modules/ConstraintsStatex/RiftConstraintsState.cpp
 #}}}
-#3D sources  {{{1
-threed_sources = ./objects/Gauss/GaussPenta.h\
-				     ./objects/Gauss/GaussPenta.cpp\
-				     ./objects/ElementResults/PentaP1ElementResult.h\
-				     ./objects/ElementResults/PentaP1ElementResult.cpp\
-				     ./objects/Inputs/PentaP1Input.h\
-				     ./objects/Inputs/PentaP1Input.cpp\
-				     ./objects/Elements/Penta.h\
-				     ./objects/Elements/Penta.cpp\
-				     ./objects/Elements/PentaHook.h\
-				     ./objects/Elements/PentaHook.cpp\
-				     ./objects/Elements/PentaRef.h\
-				     ./objects/Elements/PentaRef.cpp
-#}}}
-#Bamg sources  {{{1
-bamg_sources =  ./objects/Bamg/BamgGeom.h\
-				./objects/Bamg/BamgGeom.cpp\
-				./objects/Bamg/BamgMesh.h\
-				./objects/Bamg/BamgMesh.cpp\
-				./objects/Bamg/BamgOpts.h\
-				./objects/Bamg/BamgOpts.cpp\
-				./objects/Bamg/CrackedEdge.h\
-				./objects/Bamg/CrackedEdge.cpp\
-				./objects/Bamg/Curve.h\
-				./objects/Bamg/Curve.cpp\
-				./objects/Bamg/Direction.h\
-				./objects/Bamg/Direction.cpp\
-				./objects/Bamg/DoubleAndInt.h\
-				./objects/Bamg/Edge.h\
-				./objects/Bamg/Edge.cpp\
-				./objects/Bamg/GeomEdge.h\
-				./objects/Bamg/GeomEdge.cpp\
-				./objects/Bamg/GeomSubDomain.h\
-				./objects/Bamg/GeomSubDomain.cpp\
-				./objects/Bamg/GeomVertex.h\
-				./objects/Bamg/GeomVertex.cpp\
-				./objects/Bamg/Geometry.cpp\
-				./objects/Bamg/Geometry.h\
-				./objects/Bamg/ListofIntersectionTriangles.cpp\
-				./objects/Bamg/ListofIntersectionTriangles.h\
-				./objects/Bamg/EigenMetric.cpp\
-				./objects/Bamg/Metric.cpp\
-				./objects/Bamg/Metric.h\
-				./objects/Bamg/BamgQuadtree.cpp\
-				./objects/Bamg/BamgQuadtree.h\
-				./objects/Bamg/R2.h\
-				./objects/Bamg/SetOfE4.cpp\
-				./objects/Bamg/SetOfE4.h\
-				./objects/Bamg/SubDomain.h\
-				./objects/Bamg/SubDomain.cpp\
-				./objects/Bamg/AdjacentTriangle.h\
-				./objects/Bamg/AdjacentTriangle.cpp\
-				./objects/Bamg/Triangle.cpp\
-				./objects/Bamg/Triangle.h\
-				./objects/Bamg/BamgVertex.cpp\
-				./objects/Bamg/BamgVertex.h\
-				./objects/Bamg/VertexOnEdge.h\
-				./objects/Bamg/VertexOnEdge.cpp\
-				./objects/Bamg/VertexOnGeom.h\
-				./objects/Bamg/VertexOnGeom.cpp\
-				./objects/Bamg/VertexOnVertex.h\
-				./objects/Bamg/VertexOnVertex.cpp\
-				./objects/Bamg/Mesh.cpp\
-				./objects/Bamg/Mesh.h\
+#3D sources  {{{
+threed_sources = ./classes/gauss/GaussPenta.h\
+				     ./classes/gauss/GaussPenta.cpp\
+				     ./classes/objects/ElementResults/PentaP1ElementResult.h\
+				     ./classes/objects/ElementResults/PentaP1ElementResult.cpp\
+				     ./classes/objects/Inputs/PentaP1Input.h\
+				     ./classes/objects/Inputs/PentaP1Input.cpp\
+				     ./classes/objects/Elements/Penta.h\
+				     ./classes/objects/Elements/Penta.cpp\
+				     ./classes/objects/Elements/PentaHook.h\
+				     ./classes/objects/Elements/PentaHook.cpp\
+				     ./classes/objects/Elements/PentaRef.h\
+				     ./classes/objects/Elements/PentaRef.cpp
+#}}}
+#Bamg sources  {{{
+bamg_sources =  ./classes/bamg/bamgobjects.h\
+				./classes/bamg/BamgGeom.h\
+				./classes/bamg/BamgGeom.cpp\
+				./classes/bamg/BamgMesh.h\
+				./classes/bamg/BamgMesh.cpp\
+				./classes/bamg/BamgOpts.h\
+				./classes/bamg/BamgOpts.cpp\
+				./classes/bamg/CrackedEdge.h\
+				./classes/bamg/CrackedEdge.cpp\
+				./classes/bamg/Curve.h\
+				./classes/bamg/Curve.cpp\
+				./classes/bamg/Direction.h\
+				./classes/bamg/Direction.cpp\
+				./classes/bamg/DoubleAndInt.h\
+				./classes/bamg/Edge.h\
+				./classes/bamg/Edge.cpp\
+				./classes/bamg/GeomEdge.h\
+				./classes/bamg/GeomEdge.cpp\
+				./classes/bamg/GeomSubDomain.h\
+				./classes/bamg/GeomSubDomain.cpp\
+				./classes/bamg/GeomVertex.h\
+				./classes/bamg/GeomVertex.cpp\
+				./classes/bamg/Geometry.cpp\
+				./classes/bamg/Geometry.h\
+				./classes/bamg/ListofIntersectionTriangles.cpp\
+				./classes/bamg/ListofIntersectionTriangles.h\
+				./classes/bamg/EigenMetric.cpp\
+				./classes/bamg/Metric.cpp\
+				./classes/bamg/Metric.h\
+				./classes/bamg/BamgQuadtree.cpp\
+				./classes/bamg/BamgQuadtree.h\
+				./classes/bamg/R2.h\
+				./classes/bamg/SetOfE4.cpp\
+				./classes/bamg/SetOfE4.h\
+				./classes/bamg/SubDomain.h\
+				./classes/bamg/SubDomain.cpp\
+				./classes/bamg/AdjacentTriangle.h\
+				./classes/bamg/AdjacentTriangle.cpp\
+				./classes/bamg/Triangle.cpp\
+				./classes/bamg/Triangle.h\
+				./classes/bamg/BamgVertex.cpp\
+				./classes/bamg/BamgVertex.h\
+				./classes/bamg/VertexOnEdge.h\
+				./classes/bamg/VertexOnEdge.cpp\
+				./classes/bamg/VertexOnGeom.h\
+				./classes/bamg/VertexOnGeom.cpp\
+				./classes/bamg/VertexOnVertex.h\
+				./classes/bamg/VertexOnVertex.cpp\
+				./classes/bamg/Mesh.cpp\
+				./classes/bamg/Mesh.h\
 				./shared/Bamg/Abs.h \
 				./shared/Bamg/BigPrimeNumber.h\
@@ -609,25 +649,44 @@
 				./modules/BamgTriangulatex/BamgTriangulatex.h
 #}}}
-#Kriging sources  {{{1
+#Kriging sources  {{{
 kriging_sources = ./Container/Observations.h\
 						./Container/Observations.cpp\
-						./objects/Kriging/Variogram.h \
-						./objects/Kriging/GaussianVariogram.h\
-						./objects/Kriging/GaussianVariogram.cpp\
-						./objects/Kriging/ExponentialVariogram.h\
-						./objects/Kriging/ExponentialVariogram.cpp\
-						./objects/Kriging/SphericalVariogram.h\
-						./objects/Kriging/SphericalVariogram.cpp\
-						./objects/Kriging/PowerVariogram.h\
-						./objects/Kriging/PowerVariogram.cpp\
-						./objects/Kriging/Quadtree.h\
-						./objects/Kriging/Quadtree.cpp\
-						./objects/Kriging/Observation.h\
-						./objects/Kriging/Observation.cpp\
+						./classes/kriging/Variogram.h \
+						./classes/kriging/GaussianVariogram.h\
+						./classes/kriging/GaussianVariogram.cpp\
+						./classes/kriging/ExponentialVariogram.h\
+						./classes/kriging/ExponentialVariogram.cpp\
+						./classes/kriging/SphericalVariogram.h\
+						./classes/kriging/SphericalVariogram.cpp\
+						./classes/kriging/PowerVariogram.h\
+						./classes/kriging/PowerVariogram.cpp\
+						./classes/kriging/Quadtree.h\
+						./classes/kriging/Quadtree.cpp\
+						./classes/kriging/Observation.h\
+						./classes/kriging/Observation.cpp\
 						./modules/Krigingx/Krigingx.cpp\
 						./modules/Krigingx/Krigingx.h
 
-#}}}
-#Kml sources  {{{1
+#For parallel kriging, only difference is ./modules/Krigingx/pKrigingx.cpp with no multithreading
+pkriging_sources = ./Container/Observations.h\
+						./Container/Observations.cpp\
+						./classes/kriging/Variogram.h \
+						./classes/kriging/GaussianVariogram.h\
+						./classes/kriging/GaussianVariogram.cpp\
+						./classes/kriging/ExponentialVariogram.h\
+						./classes/kriging/ExponentialVariogram.cpp\
+						./classes/kriging/SphericalVariogram.h\
+						./classes/kriging/SphericalVariogram.cpp\
+						./classes/kriging/PowerVariogram.h\
+						./classes/kriging/PowerVariogram.cpp\
+						./classes/kriging/Quadtree.h\
+						./classes/kriging/Quadtree.cpp\
+						./classes/kriging/Observation.h\
+						./classes/kriging/Observation.cpp\
+						./modules/Krigingx/pKrigingx.cpp\
+						./modules/Krigingx/Krigingx.h
+
+#}}}
+#Kml sources  {{{
 kml_sources = ./modules/Exp2Kmlx/Exp2Kmlx.h\
 			     ./modules/Exp2Kmlx/Exp2Kmlx.cpp\
@@ -642,60 +701,60 @@
 			     ./modules/KMLOverlayx/KMLOverlayx.h\
 			     ./modules/KMLOverlayx/KMLOverlayx.cpp\
-			     ./objects/KML/KML_Attribute.cpp\
-			     ./objects/KML/KML_Attribute.h\
-			     ./objects/KML/KML_Comment.cpp\
-			     ./objects/KML/KML_Comment.h\
-			     ./objects/KML/KML_ColorStyle.cpp\
-			     ./objects/KML/KML_ColorStyle.h\
-			     ./objects/KML/KML_Container.cpp\
-			     ./objects/KML/KML_Container.h\
-			     ./objects/KML/KML_Document.cpp\
-			     ./objects/KML/KML_Document.h\
-			     ./objects/KML/KML_Feature.cpp\
-			     ./objects/KML/KML_Feature.h\
-			     ./objects/KML/KML_File.cpp\
-			     ./objects/KML/KML_File.h\
-			     ./objects/KML/KML_Folder.cpp\
-			     ./objects/KML/KML_Folder.h\
-			     ./objects/KML/KML_Geometry.cpp\
-			     ./objects/KML/KML_Geometry.h\
-			     ./objects/KML/KML_GroundOverlay.cpp\
-			     ./objects/KML/KML_GroundOverlay.h\
-			     ./objects/KML/KML_Icon.cpp\
-			     ./objects/KML/KML_Icon.h\
-			     ./objects/KML/KML_LatLonBox.cpp\
-		  	     ./objects/KML/KML_LatLonBox.h\
-			     ./objects/KML/KML_LinearRing.cpp\
-			     ./objects/KML/KML_LinearRing.h\
-			     ./objects/KML/KML_LineString.cpp\
-			     ./objects/KML/KML_LineString.h\
-			     ./objects/KML/KML_LineStyle.cpp\
-			     ./objects/KML/KML_LineStyle.h\
-			     ./objects/KML/KML_MultiGeometry.cpp\
-			     ./objects/KML/KML_MultiGeometry.h\
-			     ./objects/KML/KML_Object.cpp\
-			     ./objects/KML/KML_Object.h\
-			     ./objects/KML/KML_Overlay.cpp\
-			     ./objects/KML/KML_Overlay.h\
-			     ./objects/KML/KML_Point.cpp\
-			     ./objects/KML/KML_Point.h\
-			     ./objects/KML/KML_Placemark.cpp\
-			     ./objects/KML/KML_Placemark.h\
-			     ./objects/KML/KML_Polygon.cpp\
-			     ./objects/KML/KML_Polygon.h\
-			     ./objects/KML/KML_PolyStyle.cpp\
-			     ./objects/KML/KML_PolyStyle.h\
-			     ./objects/KML/KML_Style.cpp\
-			     ./objects/KML/KML_Style.h\
-			     ./objects/KML/KML_StyleSelector.cpp\
-			     ./objects/KML/KML_StyleSelector.h\
-			     ./objects/KML/KML_SubStyle.cpp\
-			     ./objects/KML/KML_SubStyle.h\
-			     ./objects/KML/KML_Unknown.cpp\
-			     ./objects/KML/KML_Unknown.h\
-			     ./objects/KML/KMLFileReadUtils.cpp\
-			     ./objects/KML/KMLFileReadUtils.h
-#}}}
-#Petsc sources  {{{1
+			     ./classes/objects/KML/KML_Attribute.cpp\
+			     ./classes/objects/KML/KML_Attribute.h\
+			     ./classes/objects/KML/KML_Comment.cpp\
+			     ./classes/objects/KML/KML_Comment.h\
+			     ./classes/objects/KML/KML_ColorStyle.cpp\
+			     ./classes/objects/KML/KML_ColorStyle.h\
+			     ./classes/objects/KML/KML_Container.cpp\
+			     ./classes/objects/KML/KML_Container.h\
+			     ./classes/objects/KML/KML_Document.cpp\
+			     ./classes/objects/KML/KML_Document.h\
+			     ./classes/objects/KML/KML_Feature.cpp\
+			     ./classes/objects/KML/KML_Feature.h\
+			     ./classes/objects/KML/KML_File.cpp\
+			     ./classes/objects/KML/KML_File.h\
+			     ./classes/objects/KML/KML_Folder.cpp\
+			     ./classes/objects/KML/KML_Folder.h\
+			     ./classes/objects/KML/KML_Geometry.cpp\
+			     ./classes/objects/KML/KML_Geometry.h\
+			     ./classes/objects/KML/KML_GroundOverlay.cpp\
+			     ./classes/objects/KML/KML_GroundOverlay.h\
+			     ./classes/objects/KML/KML_Icon.cpp\
+			     ./classes/objects/KML/KML_Icon.h\
+			     ./classes/objects/KML/KML_LatLonBox.cpp\
+		  	     ./classes/objects/KML/KML_LatLonBox.h\
+			     ./classes/objects/KML/KML_LinearRing.cpp\
+			     ./classes/objects/KML/KML_LinearRing.h\
+			     ./classes/objects/KML/KML_LineString.cpp\
+			     ./classes/objects/KML/KML_LineString.h\
+			     ./classes/objects/KML/KML_LineStyle.cpp\
+			     ./classes/objects/KML/KML_LineStyle.h\
+			     ./classes/objects/KML/KML_MultiGeometry.cpp\
+			     ./classes/objects/KML/KML_MultiGeometry.h\
+			     ./classes/objects/KML/KML_Object.cpp\
+			     ./classes/objects/KML/KML_Object.h\
+			     ./classes/objects/KML/KML_Overlay.cpp\
+			     ./classes/objects/KML/KML_Overlay.h\
+			     ./classes/objects/KML/KML_Point.cpp\
+			     ./classes/objects/KML/KML_Point.h\
+			     ./classes/objects/KML/KML_Placemark.cpp\
+			     ./classes/objects/KML/KML_Placemark.h\
+			     ./classes/objects/KML/KML_Polygon.cpp\
+			     ./classes/objects/KML/KML_Polygon.h\
+			     ./classes/objects/KML/KML_PolyStyle.cpp\
+			     ./classes/objects/KML/KML_PolyStyle.h\
+			     ./classes/objects/KML/KML_Style.cpp\
+			     ./classes/objects/KML/KML_Style.h\
+			     ./classes/objects/KML/KML_StyleSelector.cpp\
+			     ./classes/objects/KML/KML_StyleSelector.h\
+			     ./classes/objects/KML/KML_SubStyle.cpp\
+			     ./classes/objects/KML/KML_SubStyle.h\
+			     ./classes/objects/KML/KML_Unknown.cpp\
+			     ./classes/objects/KML/KML_Unknown.h\
+			     ./classes/objects/KML/KMLFileReadUtils.cpp\
+			     ./classes/objects/KML/KMLFileReadUtils.h
+#}}}
+#Petsc sources  {{{
 petsc_sources= ./toolkits/petsc\
 					./toolkits/petsc/patches\
@@ -726,4 +785,9 @@
 					./toolkits/petsc/patches/ISSMToPetscInsertMode.cpp\
 					./toolkits/petsc/patches/ISSMToPetscNormMode.cpp\
+					./toolkits/petsc/objects/petscobjects.h\
+					./toolkits/petsc/objects/PetscMat.h\
+					./toolkits/petsc/objects/PetscMat.cpp\
+					./toolkits/petsc/objects/PetscVec.h\
+					./toolkits/petsc/objects/PetscVec.cpp\
 					./toolkits/petsc/petscincludes.h\
 					./shared/Numerics/PetscOptionsFromAnalysis.cpp\
